'use strict'

// Imports
const env = require("../toolbox").env
const utils = require("../toolbox").utils;
const Queue = require("./queue")
const Differencify = require('differencify');

class Browser {

    constructor() {
        this.browser = null
    }

    async execute(queue) {
        if (queue === null || queue === undefined || !(queue instanceof Queue)) {
            throw "Queue is not valid"
        }
        const differencify = new Differencify()
        await differencify.launchBrowser(env.config)
        await Promise.all(queue.methods.map(async config => {
            env.moduleSetup(config.setup)
            let page = await differencify.init({testName: config.testName, chain: true }).newPage()
            await differencify.setViewPort({ width: config.version.width, height: config.version.height })
            await differencify.goto(config.url)
            await utils.scrollPage(page)
            await differencify.screenshot()
                .toMatchSnapshot()
                .close()
                .end();
            await differencify.cleanup()
        }))
    }
}

module.exports = Browser